import type { SensitiveTextComponent } from "./SensitiveText";
import type { PackageSelectorComponent } from "./PackageSelector";
import type { TextComponent } from "./Text";
import type { RadioButtonsComponent } from "./RadioButtons";
import type { ListComponent } from "./List";
import type { AccountSelectorComponent } from "./Account";
import type { ContainerImageSelectorComponent } from "./ContainerImageSelector";
import type { CheckboxComponent } from "./Checkbox";
import type { SelectComponent } from "./Select";
import type { NumberComponent } from "./Number";
import type { InlineListComponent } from "./InlineList/InlineList";
import type { CodeEditorComponent } from "./CodeEditor";
import { GitSourceSelectorComponent } from "./GitSourceSelector";
import { MultilineTextComponent } from "./MultilineText";
import { NoteExpression } from "./Note";
import { KubernetesObjectStatusComponent } from "./Kubernetes/KubernetesObjectStatus";

export type StepInputComponent =
    | SensitiveTextComponent
    | PackageSelectorComponent
    | ContainerImageSelectorComponent
    | TextComponent
    | MultilineTextComponent
    | RadioButtonsComponent
    | ListComponent
    | CheckboxComponent
    | SelectComponent
    | NumberComponent
    | InlineListComponent
    | AccountSelectorComponent
    | CodeEditorComponent
    | KubernetesObjectStatusComponent
    | GitSourceSelectorComponent;

export type DeploymentTargetInputComponent =
    | SensitiveTextComponent
    | TextComponent
    | MultilineTextComponent
    | RadioButtonsComponent
    | AccountSelectorComponent
    | CheckboxComponent
    | SelectComponent
    | NumberComponent;

export type CommonInputProps = {
    label: string;
    expandoLabel?: string;
    helpText: string;
    note?: NoteExpression[];
    expandoContextualHelp?: NoteExpression[];
};
